#include "example.moc"
#include <qpainter.h>
#include <qlineedit.h>
#include <qxembed.h>
#include <qpopupmenu.h>



ExampleApplet::ExampleApplet( QWidget* parent, const char* name )
    : KApplet( parent, name )
{
    lined = new QLineEdit( this );
    lined->setText("edit me");
}

ExampleApplet::~ExampleApplet()
{
}

#define H_STRING "I'm a horizontal applet"
#define V_STRING "I'm a vertical applet"
void ExampleApplet::setupGeometry( Orientation orientation, int width, int height )
{
    setMinimumSize( QSize(0,0) ); // no minimum
    setFont( QFont("times-24") );
    QFontMetrics fm( fontMetrics() );
    if ( orientation == Vertical )
	setMinimumHeight( fm.width( V_STRING )+20 );
    else
	setMinimumWidth( fm.width( H_STRING ) );

    KApplet::setupGeometry( orientation, width, height );
}


void ExampleApplet::resizeEvent( QResizeEvent* )
{
    lined->setGeometry( 0, 0, width(), 20 );
}

void ExampleApplet::paintEvent( QPaintEvent* )
{
    QPainter p( this );
    if ( orientation() == Vertical ) {
	p.saveWorldMatrix();
	p.translate( rect().center().x(), 20 );
	p.rotate( 90 );
	p.drawText( 0, 0, V_STRING );
	p.restoreWorldMatrix();
    } else {
	p.drawText( 0, 20 + fontMetrics().ascent(), H_STRING );
    }
}

void ExampleApplet::mousePressEvent( QMouseEvent* e )
{
    if(e->button() == QMouseEvent::RightButton){
        QPopupMenu* menu = new QPopupMenu;
        menu->insertItem("Do something with ExampleApplet");
        menu->insertItem("Move", this, SLOT( moveRequest() ) );
        menu->insertSeparator();
        menu->insertItem("Remove", this, SLOT( removeRequest() ));

        menu->exec( e->globalPos() );
        delete menu;
    }
    else
        KApplet::mousePressEvent(e);
}
