/*
 * (C) Daniel M. Duley (mosfet@kde.org) KDE artistic license.
 */

#ifndef __PANEL_DIALOGS_H
#define __PANEL_DIALOGS_H

#include <qdialog.h>
#include <qlineedit.h>
#include <qcheckbox.h>
#include <kiconloaderdialog.h>

class PanelExeDialog : public QDialog
{
public:
    PanelExeDialog(const QString &path, const QString &pixmap=QString::null,
                   const QString &cmd=QString::null, bool inTerm=false,
                   QWidget *parent=0, const char *name=0);
    bool useTerminal(){return(termBtn->isChecked());}
    const QString commandLine(){return(clEdit->text());}
    const QString icon(){return(iconBtn->icon());}
protected:
    QLineEdit *clEdit;
    KIconLoaderButton *iconBtn;
    QCheckBox *termBtn;
};

#endif

