#ifndef __INTERNAL_APPLET_H
#define __INTERNAL_APPLET_H

#include <qwidget.h>

/**
 * Inline class to emulate an applet for internal applets.
 */
class InternalApplet : public QWidget
{
    Q_OBJECT
public:
    enum Position{Left=0, Right, Top, Bottom};
    enum Stretch{Fixed=0, Small, Medium, Large, Huge};
    InternalApplet(QWidget *parent, const char *name, WFlags f=0)
        : QWidget(parent, name, f) { s = Fixed; }
    virtual void setupGeometry(Orientation orient, int width,
                               int height){o = orient;}
    void setStretch(Stretch size){s=size;}
    Stretch stretch(){return (s);}
    Orientation orientation(){return (o);}
    Position position(){return(pos);}
    void setPosition(Position p){pos = p;}
public slots:
    void removeRequest(){emit internalRemove();}
    void moveRequest(){emit internalMove();}
signals:
    void internalRemove();
    void internalMove();
protected:
    Stretch s;
    Qt::Orientation o;
    Position pos;
};

#endif
