#ifndef APPLETS_H
#define APPLETS_H

#include "../../internalapplet.h"

#include <qlist.h>
#include <qxembed.h>

// Hacky class that is the same as QXEmbed, but does not destroy its
// window in the destructor. It would be nice if Qt would have support 
// for this.

class KXEmbed: public QXEmbed
{
public:
    KXEmbed(QWidget *parent=0L, const char *name=0L, WFlags f=0);
    ~KXEmbed();
};


class DockAreaApplet : public InternalApplet
{
    Q_OBJECT
public:

    DockAreaApplet( QWidget* parent, const char* name = 0 );
    ~DockAreaApplet();

    QSize sizeHint() const;
    void setupGeometry( Orientation orientation, int width, int height );

protected:
    void resizeEvent( QResizeEvent* );
    void paintEvent( QPaintEvent* );

private slots:
    void dockWindowAdd( WId );
    void updateDockWindows();
    void layoutDockingArea();

private:
    int want_width;
    int want_height;

    QList<KXEmbed> m_Docks;
};

#endif
