/*
 * (C) Daniel M. Duley (mosfet@kde.org) KDE artistic license.
 */

#ifndef __MINIPAGER_H
#define __MINIPAGER_H

#include "../../internalapplet.h"
#include <qvaluelist.h>
#include <qbutton.h>
#include <qlayout.h>

// we use our own arrow class because we want to make sure the button frame is
// only 1 pixel with any given style (we're size sensitive here)
class KMiniPagerArrow : public QButton
{
    Q_OBJECT
public:
    KMiniPagerArrow(QWidget *parent=0, const char *name=0)
        : QButton(parent, name){;}
    void setPosition(InternalApplet::Position p);
protected:
    void paintEvent(QPaintEvent *ev);
    ArrowType arrow;
};

class KMiniPagerButton : public QButton
{
    Q_OBJECT
public:
    KMiniPagerButton(int desk, QWidget *parent=0, const char *name=0);
protected slots:
    void slotClicked();
signals:
    void deskChange(int desk);
protected:
    void paintEvent(QPaintEvent *ev);
    QString deskStr;
    int deskNum;
};

class KMiniPager : public InternalApplet
{
    Q_OBJECT
public:
    KMiniPager(QWidget *parent=0, const char *name=0);
    void setupGeometry(Orientation orient, int w, int h);
    void setupSmallGeometry(Orientation orient, int w, int h, int deskNum,
                            Position location);
public slots:
    void slotSetDesktop(int desktop);
    void slotSetDesktopCount(int count);
    void slotButtonClicked(int desk);
protected:
    void allocateButtons();
    QValueList<KMiniPagerButton*>btnList;
    QGridLayout *layout;
    QBoxLayout *mainlayout;
    KMiniPagerArrow *launchBtn;
    int curDesk;
};

#endif

