#ifndef ITEMAREA_H
#define ITEMAREA_H

#include <qvbox.h>
#include <qlist.h>
#include <panel.h>
#include "panner.h"
#include "panelbutton.h"

class QPixmap;
class ItemArea : public Panner
{
    Q_OBJECT
public:
    ItemArea(const QString &configGroup, Orientation orientation, int strut,
             QWidget* parent, const char* name = 0);
    ~ItemArea();
    void setButtonSize(int extent, bool relayout=false)
        {btnSize = extent; if(relayout) layoutChildren();}
    void setPosition(Position p, bool relayout=false)
        {panelPos = p; if(relayout) layoutChildren();}
    Position position(){return(panelPos);}
    int buttonSize(){return(btnSize);}
    void setOrientation(Orientation orientation);
public slots:
    void saveButtonConfig();
    void addButton(PanelButton *btn);
    // does not delete, just removes from internal structures and config.
    void removeButton(PanelButton *btn);
protected:
    void dragEnterEvent(QDragEnterEvent *ev);
    void dropEvent(QDropEvent *ev);
protected slots:
    virtual void layoutChildren(); 
private:
    QList<PanelButton>btnList;
    int btnSize;
    Position panelPos;
    QString configStr;
};

#endif
