#include "panel.h"
#include <klocale.h>
#include <kglobal.h>
#include <kstddirs.h>
#include <kuniqueapp.h>
#include <dcopclient.h>
#include <kcmdlineargs.h>
#include <stdio.h>
#include <kaboutdata.h>


static const char *description = 
	I18N_NOOP("KDE Panel which kicks ass.");

static const char *version = "v0.0.1";


// -----------------------------------------------------------------------------

class KickerApp : public KUniqueApplication
{
    Panel* p;
public:    
    KickerApp();
    ~KickerApp();
};

// -----------------------------------------------------------------------------

KickerApp::KickerApp()
    : KUniqueApplication()
{
    KGlobal::dirs()->addResourceType("mini", KStandardDirs::kde_default("data") +
                                     "kicker/pics/mini");
    
    KGlobal::dirs()->addResourceType("icon", KStandardDirs::kde_default("data") +
                                     "kicker/pics");
    KGlobal::locale()->insertCatalogue("libkonq");
    
    p = new Panel(Bottom, 64);
    setMainWidget(p);
    p->show();
}

KickerApp::~KickerApp()
{
}


int main( int argc, char ** argv )
{
    KAboutData aboutData( "kicker", I18N_NOOP("The KDE Panel"), 
       version, description, KAboutData::License_BSD, 
       "(c) 1999-2000, The KDE Developers");
    aboutData.addAuthor("Matthias Ettrich",0, "ettrich@kde.org");
    aboutData.addAuthor("Daniel M. Duley",0, "mosfet@kde.org");

    KCmdLineArgs::init( argc, argv, &aboutData );
//    KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.

    if (!KickerApp::start())
    {
       fprintf(stderr, "kicker is already running!\n");
       return (0);
    }

    KickerApp a;

    return a.exec();
}
