#ifndef PANNER_H
#define PANNER_H
#include <qscrollview.h>
#include <qtimer.h>
class QPushButton;
class Panner : public QScrollView
{
    Q_OBJECT

public:
    Panner( Orientation orientation, int strut, QWidget* parent, const char* name = 0);
    ~Panner();

    bool eventFilter( QObject *, QEvent * );

    inline Orientation orientation() const;
    inline int strut() const;
    virtual void setOrientation(Orientation orientation);

protected:
    void resizeEvent( QResizeEvent* );

    // call this whenever the layout has to be redone. Multiple calls will be compacted.
    void deferredLayoutUpdate();

    //CT pure virtual to force implement in all users ( the 3 areas )
    virtual void layoutChildren() = 0;


private slots:
    void scrollRight();
    void scrollLeft();
    void scrollUp();
    void scrollDown();

    void cleanupChildren();
    
    void updateTimerDone();

private:
    QPushButton* leftArrow;
    QPushButton* rightArrow;
    QPushButton* upArrow;
    QPushButton* downArrow;
    Orientation orient;
    QTimer updateTimer;
    int strt;

    void updateArrows();
    void setButtonPixmap( QPushButton* b, Qt::ArrowType type );
    
};

inline Qt::Orientation Panner::orientation() const
{
    return orient;
}

inline int Panner::strut() const
{
    return strt;
}

#endif
